unit HttpClientMain;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.Net.HttpClient,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin,
  SpringHttpClient;

type
  [UriPath('{action}')]
  APITypicode = interface(IInvokable) ['{54E1D5F5-EE4B-4F69-8025-55ED83960C0D}']
    function  Albums: IHTTPResponse; overload;
    [UriPath('{id}')]
    function  Albums(id: integer): IHTTPResponse; overload;
    function  Comments: IHTTPResponse; overload;
    [UriPath('{id}')]
    function  Comments(id: integer): IHTTPResponse; overload;
  end;

  TfrmHttpClient = class(TForm)
    btnAlbums: TButton;
    lbLog: TListBox;
    btnAlbum: TButton;
    btnComments: TButton;
    btnComment: TButton;
    inpAlbumID: TSpinEdit;
    inpCommentID: TSpinEdit;
    procedure btnAlbumClick(Sender: TObject);
    procedure btnAlbumsClick(Sender: TObject);
    procedure btnCommentClick(Sender: TObject);
    procedure btnCommentsClick(Sender: TObject);
  private
    function  Connection: APITypicode;
    procedure ShowResponse(const response: IHTTPResponse);
  public
  end;

var
  frmHttpClient: TfrmHttpClient;

implementation

{$R *.dfm}

procedure TfrmHttpClient.btnAlbumClick(Sender: TObject);
begin
  ShowResponse(Connection.Albums(inpAlbumID.Value));
end;

procedure TfrmHttpClient.btnAlbumsClick(Sender: TObject);
var
  response: IHTTPResponse;
begin
  response := RESTClient<APITypicode>
                .Https('jsonplaceholder.typicode.com', '/')
                .Invoke
                .Albums;
  ShowResponse(response);
end;

procedure TfrmHttpClient.btnCommentClick(Sender: TObject);
begin
  ShowResponse(Connection.Comments(inpCommentID.Value));
end;

procedure TfrmHttpClient.btnCommentsClick(Sender: TObject);
begin
  ShowResponse(Connection.Comments);
end;

function TfrmHttpClient.Connection: APITypicode;
begin
  Result := RESTClient<APITypicode>.Https('jsonplaceholder.typicode.com', '/').Invoke;
end;

procedure TfrmHttpClient.ShowResponse(const response: IHTTPResponse);
begin
  lbLog.Items.Text :=
    response.StatusCode.ToString + ' ' + response.StatusText + #13#10
    + response.ContentAsString;
end;

end.
